﻿Public Class FrmDbms

    Public Sub FrmDbms_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BtnDbName.PerformClick()
        BtnShowTables.PerformClick()
        BtnDisplayFields.PerformClick()

        SetAutoCompletion("SHOW DATABASES", CbDbName)
    End Sub

    Private Sub BtnDbName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDbName.Click
        CbDbName.Text = GetSingleValue("SELECT DATABASE()")
    End Sub

    Private Sub BtnShowTables_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnShowTables.Click
        SetAutoCompletion("SHOW TABLES IN " & CbDbName.Text, CbTableName)
    End Sub

    Private Sub BtnDisplayFields_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDisplayFields.Click
        If CbTableName.Text = "" Then
            MessageBox.Show("Please select a table first.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            TableQuery("DESCRIBE " & CbDbName.Text & "." & CbTableName.Text, DtgFieldNames)
        End If
    End Sub

    Private Sub CbTableName_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CbTableName.TextChanged
        If CbTableName.Text = "" Then
            DtgFieldNames.DataSource = Nothing
        Else
            BtnDisplayFields.PerformClick()
        End If
    End Sub

    Private Sub BtnAddDb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddDb.Click
        Query("Added new database successfully.", "CREATE DATABASE " & TxtNewDbName.Text)
        Query(String.Format("CREATE TABLE `{0}`.`users` ( `id` int(11) NOT NULL, `type` varchar(64) NOT NULL, `company_name` varchar(64) NOT NULL, `email` varchar(128) NOT NULL, `password` varchar(128) NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1;", TxtNewDbName.Text))
        Query(String.Format("INSERT INTO `{0}`.`users` (`id`, `type`, `company_name`, `email`, `password`) VALUES (1, 'admin', 'Ad miniscule', 'admin@admin.com', '123qweasd'), (2, 'supplier', 'Support and lair', 'supplier@supplier.supplier', '123qweasd'), (3, 'company', 'Comp and Annie', 'company@company.company', '123qweasd');", TxtNewDbName.Text))
        Query(String.Format("CREATE TABLE `{0}`.`items` ( `id` int(32) NOT NULL, `user_id` int(64) NOT NULL, `date_created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, `type` varchar(32) NOT NULL, `name` varchar(32) NOT NULL, `price` double NOT NULL, `description` varchar(32) NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`item_prices` ( `id` int(11) NOT NULL, `item_id` int(32) NOT NULL, `user_id` int(11) NOT NULL, `price` double NOT NULL, `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`payments` ( `id` int(11) NOT NULL, `date_created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, `user_id` int(11) NOT NULL, `total_payment` double NOT NULL, `received_amount` double NOT NULL, `change` double NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`stock_in` ( `id` int(11) NOT NULL, `item_id` int(11) NOT NULL, `user_id` int(11) NOT NULL, `date_created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, `quantity` int(64) NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`stock_out` ( `id` int(11) NOT NULL, `item_id` int(11) NOT NULL, `user_id` int(11) NOT NULL, `date_created` datetime DEFAULT CURRENT_TIMESTAMP, `quantity` int(64) NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`stock_out_orders` ( `id` int(11) NOT NULL, `item_id` int(11) NOT NULL, `user_id` int(11) NOT NULL, `date_created` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, `quantity` int(32) NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1; CREATE TABLE `{0}`.`transactions` ( `id` int(32) NOT NULL, `user_id` int(11) NOT NULL, `type` varchar(32) NOT NULL, `date` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP, `details` longtext NOT NULL ) ENGINE=InnoDB DEFAULT CHARSET=latin1;", TxtNewDbName.Text))
    End Sub

    Private Sub BtnAddNewTable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNewTable.Click
        FrmManageTable.SaveType = "add"
        FrmManageTable.ShowDialog()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FrmManageTable.SaveType = "update"
        FrmManageTable.ShowDialog()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim ConfirmDeletion = MessageBox.Show("Are you sure to delete " & CbTableName.Text & " table?", PROGRAM_NAME, MessageBoxButtons.YesNo, MessageBoxIcon.Question)

        If ConfirmDeletion = DialogResult.Yes Then
            Query("Deleted table " & CbTableName.Text & " successfully.", "DROP TABLE `" & CbTableName.Text & "`")
            FrmDbms_Load(sender, e)
        Else
            MessageBox.Show(CbTableName.Text & " is safe.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If

    End Sub

End Class