﻿Public Class FrmStockOutOrder

    Public SelectedItemId = 0
    Public SelectedStockInId = 0
    Public SelectedStockOutId = 0
    Public SelectedItemQuantity = 0
    Public TransactionStartingNumber = 2000

    Private SaveType = 0

    Private Sub CalculatePayment()
        Dim TotalPayments = 0
        For Each Row As DataGridViewRow In DtgStockOut.Rows
            TotalPayments += Val(Row.Cells("Total").Value)
        Next
        TxtTotalPayment.Text = TotalPayments
    End Sub


    Private Sub TxtQuantity_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TxtQuantity.KeyPress, TxtTotalPayment.KeyPress, TxtReceivedAmount.KeyPress, TxtChange.KeyPress
        e.Handled = Not Char.IsNumber(e.KeyChar)
    End Sub

    Private Sub BtnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSearch.Click
        FrmStockOutSearch.ShowDialog()
    End Sub

    Private Sub FrmStockOutOrder_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Query(String.Format("SELECT stock.id AS `id`, item.type AS `Item type`, item.name AS `Item name`, SUM(stock.quantity) AS `Quantity`, item.price AS `Price`, (`Quantity` * item.price) AS `Total` FROM `stock_out_orders` AS stock INNER JOIN items AS item ON stock.item_id = item.id INNER JOIN users as user ON stock.user_id = user.id WHERE stock.user_id={0} GROUP BY `Name`", UserId), DtgStockOut)
        SetAutoCompletion("SELECT DISTINCT company_name FROM users WHERE type <> 'admin'", CbCompany)

        If DtgStockOut.Rows.Count > 0 Then
            CalculatePayment()
        End If

        TransactionStartingNumber = Val(GetSingleValue("SELECT MAX(tracking_number) FROM transactions"))

        If TransactionStartingNumber <> 2000 Then
            TransactionStartingNumber = 2000
        End If

        LblTransactionQty.Text = TransactionStartingNumber
    End Sub

    Private Sub TxtQuantity_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtQuantity.TextChanged
        If Val(TxtQuantity.Text) > SelectedItemQuantity Then
            MessageBox.Show("Out of stock." & vbNewLine & "Please try stocking in some items", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)
            TxtQuantity.Clear()
        Else
            LblQtyRemaining.Text = Val(SelectedItemQuantity) - Val(TxtQuantity.Text) & " pcs remaining."
        End If
    End Sub

    Private Sub BtnAddItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddItem.Click
        Dim StockCount = GetSingleValue(String.Format("SELECT COUNT(stock.id) FROM `stock_out_orders` AS stock INNER JOIN items AS item ON stock.item_id = item.id WHERE item.type='{0}' AND item.name='{1}'", TxtType.Text, TxtName.Text))
        Dim StockId = GetSingleValue(String.Format("SELECT stock.id FROM `stock_out_orders` AS stock INNER JOIN items AS item ON stock.item_id = item.id WHERE item.type='{0}' AND item.name='{1}'", TxtType.Text, TxtName.Text))
        Dim StockQuantity = GetSingleValue("SELECT quantity FROM stock_out_orders WHERE id=" & StockId)
        Dim TotalStockQuantity As Integer = 0
        Dim StockDifference = SelectedItemQuantity - Val(TxtQuantity.Text)

        If TxtType.Text = "" And TxtName.Text = "" And TxtQuantity.Text = "" And TxtPrice.Text = "" Then
            MessageBox.Show("Please provide all the needed data.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Else
            If SaveType = 0 Then
                If StockCount = 0 Then
                    Query("Added a new stock successfully", String.Format("INSERT INTO `stock_out_orders`(`item_id`, `user_id`, `quantity`) VALUES ({0},{1},{2})", SelectedItemId, UserId, TxtQuantity.Text))
                Else
                    TotalStockQuantity = StockQuantity + Val(TxtQuantity.Text)
                    Query("Added a new stock successfully", String.Format("UPDATE `stock_out_orders` SET `item_id`={0},`user_id`={1},`quantity`={2} WHERE id={3}", SelectedItemId, UserId, TotalStockQuantity, StockId))
                End If

                Query(String.Format("UPDATE `stock_in` SET `released_quantity`={0} WHERE id={1}", TxtQuantity.Text, SelectedStockInId))

                RecordTransaction("Stock out", String.Format("Added {0} {1} worth {2}", TxtQuantity.Text, TxtName.Text, TxtPrice.Text), TransactionStartingNumber)
            ElseIf SaveType = 1 Then
                Query("Updated a stock successfully", String.Format("UPDATE `stock_out_orders` SET `item_id`={0},`user_id`={1},`quantity`={2} WHERE id={3}", SelectedItemId, UserId, TxtQuantity.Text, SelectedStockOutId))
                RecordTransaction("Stock out", String.Format("Updated {0} {1} worth {2}", TxtQuantity.Text, TxtName.Text, TxtPrice.Text), TransactionStartingNumber)
            End If

            CalculatePayment()
            BtnClearAll.PerformClick()
            FrmStockOutOrder_Load(sender, e)
        End If

    End Sub

    Private Sub BtnClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearAll.Click
        SaveType = 0
        LblQtyRemaining.Hide()
        ClearInputs(GrpItemDetails)
        ClearInputs(GrpPayment)
    End Sub

#Region "Reserve code for updating item"
    ''''''''''''''''''''''''''''
    'Reserve for updating items.
    ''''''''''''''''''''''''''''
    'Private Sub DtgItems_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DtgStockOut.CellClick

    '    If DtgStockOut.Rows.Count > 0 Then
    '        SaveType = 0

    '        With DtgStockOut.CurrentRow
    '            SelectedStockOutId = .Cells("id").Value
    '            TxtType.Text = .Cells("Item type").Value
    '            TxtName.Text = .Cells("Item name").Value

    '            Dim ItemQty = GetSingleValue(String.Format("SELECT stock.quantity FROM stock_in AS stock INNER JOIN items AS item on stock.item_id = item.id WHERE item.type='{0}' AND item.name='{1}'", TxtType.Text, TxtName.Text))
    '            SelectedItemQuantity = ItemQty
    '            LblQtyRemaining.Text = SelectedItemQuantity & " pcs remaining."
    '            LblQtyRemaining.Show()

    '            TxtQuantity.Text = .Cells("Quantity").Value
    '            TxtPrice.Text = .Cells("Price").Value
    '        End With


    '    End If
    'End Sub
#End Region

    Private Sub TxtReceivedAmount_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtReceivedAmount.TextChanged
        TxtChange.Text = Val(TxtReceivedAmount.Text) - Val(TxtTotalPayment.Text)
    End Sub

    Private Sub TxtChange_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtChange.TextChanged
        If Val(TxtChange.Text) < 0 Then
            TxtChange.Text = 0
        End If
    End Sub

    Private Sub BtnPay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPay.Click
        Dim CompanyId = GetSingleValue("SELECT id FROM users WHERE company_name='" & CbCompany.Text & "'")


        If DtgStockOut.Rows.Count > 0 Then
            For Each Row As DataGridViewRow In DtgStockOut.Rows
                Query(String.Format("INSERT INTO `stock_in`(`item_id`, `user_id`,`quantity`) VALUES ('{0}','{1}','{2}')", Row.Cells("id").Value, CompanyId, Row.Cells("Quantity").Value))
                Query(String.Format("INSERT INTO `stock_out`(`item_id`, `user_id`,`quantity`) VALUES ('{0}','{1}','{2}')", Row.Cells("id").Value, CompanyId, Row.Cells("Quantity").Value))
                Query(String.Format("INSERT INTO `payments`(`item_id`, `user_id`, `total_payment`, `received_amount`, `change`) VALUES ({0},{1},{2},{3})", Row.Cells("id").Value, CompanyId, TxtTotalPayment.Text, TxtReceivedAmount.Text, TxtChange.Text))
            Next

            MessageBox.Show("Payment is successful.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Information)

            Query("DELETE FROM stock_out_orders")
            BtnClearAll.PerformClick()
            FrmStockOutOrder_Load(sender, e)
            FrmStockOut.FrmStockOut_Load(sender, e)
        End If
    End Sub

End Class